﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication7
{
    public partial class Form1 : Form
    {
        DataSet ds = new DataSet();

        public Form1()
        {
            InitializeComponent();

            {
                DataSet1.LineRow lineRow;
                DataSet1.MarkRow markRow;
                DataSet1.MarkDetailRow detailRow;

                lineRow = dataSet1.Line.AddLineRow("Line 1");
                markRow = dataSet1.Mark.AddMarkRow(lineRow, "M1");
                detailRow = dataSet1.MarkDetail.AddMarkDetailRow(markRow, "In Process", "BFA1");
                detailRow = dataSet1.MarkDetail.AddMarkDetailRow(markRow, "In Process",  "BFB1");
                detailRow = dataSet1.MarkDetail.AddMarkDetailRow(markRow, "In Process",  "TFA1");
                detailRow = dataSet1.MarkDetail.AddMarkDetailRow(markRow, "In Process",  "TFB1");
                detailRow = dataSet1.MarkDetail.AddMarkDetailRow(markRow, "In Process",  "WA1");
                detailRow = dataSet1.MarkDetail.AddMarkDetailRow(markRow, "In Process",  "WB1");
                

                markRow = dataSet1.Mark.AddMarkRow(lineRow, "M2");
                detailRow = dataSet1.MarkDetail.AddMarkDetailRow(markRow, "In Process",  "BFA2");
                detailRow = dataSet1.MarkDetail.AddMarkDetailRow(markRow, "In Process",  "BFB2");
                

                markRow = dataSet1.Mark.AddMarkRow(lineRow, "M3");
                detailRow = dataSet1.MarkDetail.AddMarkDetailRow(markRow, "In Process",  "BFA3");
                detailRow = dataSet1.MarkDetail.AddMarkDetailRow(markRow, "In Process",  "BFB3");
                detailRow = dataSet1.MarkDetail.AddMarkDetailRow(markRow, "In Process",  "TFA3");
                detailRow = dataSet1.MarkDetail.AddMarkDetailRow(markRow, "In Process",  "TFB3");
                
            }
            
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {

            DataSet dsGrid = new DataSet();
            dsGrid.Tables.Add(dataSet1.Line.Copy());
            
            foreach (DataRow bs in dataSet1.Line.Rows)
            {
                CreateMarkDetail(bs, dsGrid);
            }
            ultraGrid1.DataSource = dsGrid;
            ultraGrid1.Rows.ExpandAll(true);
            
        }

        private void CreateMarkDetail(DataRow lineRow, DataSet dsGrid)
        {
            DataTable dtMarkDetail = new DataTable();
            dtMarkDetail.TableName = lineRow.Field<string>("Line");

            dtMarkDetail.Columns.Add("Line", typeof(string));
            dsGrid.Tables.Add(dtMarkDetail);
            dtMarkDetail.ParentRelations.Add(dsGrid.Tables["Line"].Columns["Line"], dtMarkDetail.Columns["Line"]);

            foreach (DataRow markRow in lineRow.GetChildRows(lineRow.Table.ChildRelations[0]))
            {
                string markKey = "^" + markRow.Field<string>("mark"); 
                dtMarkDetail.Columns.Add("Separator" + markKey);
                dtMarkDetail.Columns.Add("ComponentInfo" + markKey);
                dtMarkDetail.Columns.Add("ProductionStatus" + markKey);
                dtMarkDetail.Columns.Add("Mark" + markKey);
            }

            foreach (DataRow markRow in lineRow.GetChildRows(lineRow.Table.ChildRelations[0]))
            {
                string markKey = "^" + markRow.Field<string>("Mark");
                int markItemCpt = 0;
                foreach (DataRow markItem in markRow.GetChildRows(markRow.Table.ChildRelations[0]))
                {
                    DataRow row;
                    if (dtMarkDetail.Rows.Count > markItemCpt)
                        row = dtMarkDetail.Rows[markItemCpt];
                    else
                    {
                        row = dtMarkDetail.NewRow();
                        row["Line"] = lineRow["Line"];
                        dtMarkDetail.Rows.Add(row);
                    }

                    row["ComponentInfo" + markKey] = markItem.Field<string>("ComponentInfo");
                    row["Mark" + markKey] = markItem.Field<string>("Mark");
                    row["ProductionStatus" + markKey] = markItem.Field<string>("ProductionStatus");
                    markItemCpt++;
                }
            }
            
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            ultraGrid1.UseOsThemes = DefaultableBoolean.False;
            ultraGrid1.DisplayLayout.RowConnectorStyle = RowConnectorStyle.None;
            ultraGrid1.DisplayLayout.Override.AllowColSizing = AllowColSizing.Free;

            for (int i = 1; i < ultraGrid1.DisplayLayout.Bands.Count; i++)
            {
                InitializeBandMarkDetail(ultraGrid1.DisplayLayout.Bands[i]);
            }
        }

        private void InitializeBandMarkDetail(UltraGridBand band)
        {
            UltraGridColumn col;

            band.Hidden = false;
            band.Override.AllowUpdate = Infragistics.Win.DefaultableBoolean.False;
            band.Override.AllowColMoving = AllowColMoving.NotAllowed;
            band.Override.CellClickAction = CellClickAction.CellSelect;
            band.Override.HeaderClickAction = HeaderClickAction.Select;
            band.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.False;
            band.Override.CellAppearance.BorderColor = Color.Transparent;
            band.Override.RowAppearance.BorderColor = Color.Transparent;
            band.Override.SelectTypeCol = SelectType.None;
            band.Override.SelectTypeRow = SelectType.None;
            band.Override.SelectTypeCell = SelectType.Extended;

            DataSet DsGridSource = ultraGrid1.DataSource as DataSet;

            foreach (DataColumn dc in DsGridSource.Relations[band.Key].ChildTable.Columns)
            {
                col = band.Columns[dc.ColumnName];
                col.Hidden = true;
                if (dc.ColumnName.StartsWith("Separator"))
                {
                    col.Header.Caption = "";
                    col.Width = 20;
                    col.Hidden = false;
                    
                }
                else if (dc.ColumnName.StartsWith("ComponentInfo"))
                {
                    string markKey = "^" + dc.ColumnName.Split("^"[0])[1];

                    string mark = DsGridSource.Relations[band.Key].ChildTable.Rows[0]["Mark" + markKey].ToString();

                    col.Hidden = false; 
                    col.Header.Caption = mark;
                    col.Width = 120;
                    col.Header.Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True;
                    col.Header.Appearance.BackColor = Color.LightGray;

                }
                else if (dc.ColumnName.StartsWith("ProductionStatus"))
                {
                    col.Hidden = false;
                    col.Header.Caption = "Status";
                    col.Width = 80;
                    col.Header.Appearance.BackColor = Color.LightGray;
                }
                
            }
        }

        private void ultraGrid1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
                ultraGrid1.Focus();

            {
                UIElement element = ultraGrid1.DisplayLayout.UIElement.ElementFromPoint(e.Location);
                HeaderUIElement header = element.GetAncestor(typeof(HeaderUIElement)) as HeaderUIElement;

                if (header != null)
                {
                    string markKey = "^" + header.Header.Column.Key.Split("^"[0])[1];
                    ultraGrid1.Selected.Cells.Clear();

                    UltraGridCell activeCell = null;
                    foreach (UltraGridRow r in ultraGrid1.Rows.GetRowEnumerator(GridRowType.DataRow, header.Header.Band, null))
                    {

                        if (r.Cells["ComponentInfo" + markKey].Value.ToString() != string.Empty)
                        {
                            foreach (UltraGridColumn col in header.Header.Band.Columns.Cast<UltraGridColumn>().Where(c => c.Hidden == false && c.Key.EndsWith(markKey) && !c.Key.StartsWith("Separator")))
                            {
                                if (activeCell == null)
                                {
                                    activeCell = r.Cells[col];
                                    ultraGrid1.ActiveCell = r.Cells[col];
                                }
                                ultraGrid1.Selected.Cells.Add(r.Cells[col]);
                            }
                        }
                    }

                }
            }
        }
    }
}

